## ncurses programs

=== Makefile ===
# The top level Makefile

MAKE_RECUR = $(MAKE) CC=$(CC) CFLAGS=$(CFLAGS)

all:	
	( cd JustForFun && $(MAKE_RECUR) )
	( cd basics	&& $(MAKE_RECUR) )
	( cd forms	&& $(MAKE_RECUR) )
	( cd menus	&& $(MAKE_RECUR) )
	( cd panels	&& $(MAKE_RECUR) )
	@echo 
	@echo "*********************************************"
	@echo "All files Built"
	@echo "Please move to demo/exe directory"
	@echo "Execute each file to see examples in action"
	@echo "*********************************************"
	@echo
clean:
	( cd JustForFun && $(MAKE_RECUR) $@ )
	( cd basics	&& $(MAKE_RECUR) $@ )
	( cd forms	&& $(MAKE_RECUR) $@ )
	( cd menus	&& $(MAKE_RECUR) $@ )
	( cd panels	&& $(MAKE_RECUR) $@ )
	rm -rf demo

=== JustForFun/Makefile ===
# Makefile for JustForFun Files

# A few variables

CC=gcc
LIBS=-lncurses

SRC_DIR=.
EXE_DIR=../demo/exe

EXES = \
	${EXE_DIR}/hanoi \
	${EXE_DIR}/life\
	${EXE_DIR}/magic \
	${EXE_DIR}/queens \
	${EXE_DIR}/shuffle \
	${EXE_DIR}/tt

${EXE_DIR}/%: %.o
	@mkdir -p ${EXE_DIR}
	${CC} -o $@ $< ${LIBS}

%.o: ${SRC_DIR}/%.c
	${CC} -o $@ $(CFLAGS) $(CPPFLAGS) -c $<

all:    ${EXES}

clean:
	@rm -f ${EXES}

=== basics/Makefile ===
# Makefile for JustForFun Files

# A few variables

CC=gcc
LIBS=-lncurses

SRC_DIR=.
EXE_DIR=../demo/exe

EXES = \
	${EXE_DIR}/acs_vars \
	${EXE_DIR}/hello_world \
	${EXE_DIR}/init_func_example \
	${EXE_DIR}/key_code \
	${EXE_DIR}/mouse_menu \
	${EXE_DIR}/other_border \
	${EXE_DIR}/printw_example \
	${EXE_DIR}/scanw_example \
	${EXE_DIR}/simple_attr \
	${EXE_DIR}/simple_color \
	${EXE_DIR}/simple_key \
	${EXE_DIR}/temp_leave \
	${EXE_DIR}/win_border \
	${EXE_DIR}/with_chgat

${EXE_DIR}/%: %.o
	@mkdir -p ${EXE_DIR}
	${CC} -o $@ $< ${LIBS}

%.o: ${SRC_DIR}/%.c
	${CC} -o $@ $(CFLAGS) $(CPPFLAGS) -c $<

all:    ${EXES}

clean:
	@rm -f ${EXES}

=== forms/Makefile ===
# Makefile for JustForFun Files

# A few variables

CC=gcc
LIBS=-lform -lncurses

SRC_DIR=.
EXE_DIR=../demo/exe

EXES = \
	${EXE_DIR}/form_attrib\
	${EXE_DIR}/form_options\
	${EXE_DIR}/form_simple\
	${EXE_DIR}/form_win \

${EXE_DIR}/%: %.o
	@mkdir -p ${EXE_DIR}
	${CC} -o $@ $< ${LIBS}

%.o: ${SRC_DIR}/%.c
	${CC} -o $@ $(CFLAGS) $(CPPFLAGS) -c $<

all:    ${EXES}


clean:
	@rm -f ${EXES}

=== menus/Makefile ===
# Makefile for JustForFun Files

# A few variables

CC=gcc
LIBS=-lmenu -lncurses

SRC_DIR=.
EXE_DIR=../demo/exe

EXES = \
	${EXE_DIR}/menu_attrib\
	${EXE_DIR}/menu_item_data\
	${EXE_DIR}/menu_multi_column \
	${EXE_DIR}/menu_scroll \
	${EXE_DIR}/menu_simple \
	${EXE_DIR}/menu_toggle \
	${EXE_DIR}/menu_userptr \
	${EXE_DIR}/menu_win

${EXE_DIR}/%: %.o
	@mkdir -p ${EXE_DIR}
	${CC} -o $@ $< ${LIBS}

%.o: ${SRC_DIR}/%.c
	${CC} -o $@ $(CFLAGS) $(CPPFLAGS) -c $<

all:    ${EXES}


clean:
	@rm -f ${EXES}

=== panels/Makefile ===
# Makefile for JustForFun Files

# A few variables

CC=gcc
LIBS=-lpanel -lncurses

SRC_DIR=.
EXE_DIR=../demo/exe

EXES = \
	${EXE_DIR}/panel_browse \
	${EXE_DIR}/panel_hide \
	${EXE_DIR}/panel_resize \
	${EXE_DIR}/panel_simple

${EXE_DIR}/%: %.o
	@mkdir -p ${EXE_DIR}
	${CC} -o $@ $< ${LIBS}

%.o: ${SRC_DIR}/%.c
	${CC} -o $@ $(CFLAGS) $(CPPFLAGS) -c $<

all:    ${EXES}


clean:
	@rm -f ${EXES}

## ncurses 5.7+20081213-1.maemo1+0m5

=== debian/changelog ===
ncurses (5.7+20081213-1.maemo1+0m5) unstable; urgency=low

  * This entry has been added by BIFH queue processor
    Suffix +0m5 added to package revision

 -- mika yrjola <ext-mika.2.yrjola@nokia.com>  Wed, 08 Apr 2009 16:34:51 +0300

ncurses (5.7+20081213-1.maemo1) unstable; urgency=low

  * New upstream release. Fixes: NB#109657.

 -- Alexander Shishkin <ext-alexander.shishkin@nokia.com>  Mon, 06 Apr 2009 11:33:38 +0300

ncurses (5.4-3.osso1) unstable; urgency=low

  * Added thumb. Fixes: NB#36727

 -- Yauheni Kaliuta <yauheni.kaliuta@nokia.com>  Mon,  7 Aug 2006 13:42:19 +0300

ncurses (5.4-3) unstable; urgency=low

  * Apply 20040313 and 20040320 patches from upstream
    (Closes: #237831, #227879).
  * Fix some remaining casts to "char" which need to be "signed char"
    (Closes: #237629, #237870, #238718).
  * Update Eterm terminfo entry to agree with the Debian practice of
    kbs=\177 (Closes: #237997).

 -- Daniel Jacobowitz <dan@debian.org>  Mon, 22 Mar 2004 16:12:36 -0500

ncurses (5.4-2) unstable; urgency=low

  * Oops, rebuild as non-native package.

 -- Daniel Jacobowitz <dan@debian.org>  Wed, 10 Mar 2004 15:00:31 -0500

ncurses (5.4-1) unstable; urgency=low

  * New upstream release (Closes: #230335, #236957).
  * Update to policy 3.6.1.0 (no changes required).

 -- Daniel Jacobowitz <dan@debian.org>  Wed, 10 Mar 2004 13:52:53 -0500

ncurses (5.3.20030719-5) unstable; urgency=low

  * Fix false dependency of ncurses-bin on lib64ncurses5 on sparc
    (Closes: #221174).
  * Update config.sub and config.guess (Closes: #221651).
  * Include wsvt25 and wsvt25m for knetbsd (Closes: #224172).
  * Include Eterm terminfo descriptions in ncurses-base (Closes: #227402).
  * Fix tack for standout != bold.  Half of this fix is already
    included upstream (Closes: #224443).
  * Print program name in tput error messages (Closes: #227586).
  * Update libncursesw5 to standard.

 -- Daniel Jacobowitz <dan@debian.org>  Fri, 16 Jan 2004 14:32:08 -0500

ncurses (5.3.20030719-4) unstable; urgency=low

  * Add missing build dependency for s390x (Closes: #210307).

 -- Daniel Jacobowitz <dan@debian.org>  Fri,  7 Nov 2003 14:05:42 -0500

ncurses (5.3.20030719-3) unstable; urgency=low

  * Apply patch from Thomas Dickey for a problem with the dl1 capability
    (Closes: #215805).
  * Cross-compile when building 64-bit libraries, since the S/390 build
    systems can not run s390x executables.
  * Correct a comment typo (Closes: #215806).

 -- Daniel Jacobowitz <dan@debian.org>  Mon, 20 Oct 2003 23:01:41 -0400

ncurses (5.3.20030719-2) unstable; urgency=low

  * Add 64-bit libraries for sparc64 (non-wide only) (Closes: #204418).
  * Clarified description for libncursesw5-dev (Closes: #204670).
  * Import upstream fix for Big5 display (Closes: #204889).

 -- Daniel Jacobowitz <dan@debian.org>  Wed, 27 Aug 2003 21:15:11 -0400

ncurses (5.3.20030719-1) unstable; urgency=low

  * New upstream snapshot.
    - Includes GNU/FreeBSD support (Closes: #200397).
    - Warning fix for character array subscripts (Closes: #195732).
    - Update use of __attribute__ for C++ (Closes: #195230).
  * Move the Cygwin terminfo to ncurses-base.

 -- Daniel Jacobowitz <dan@debian.org>  Sun, 20 Jul 2003 15:22:51 -0400

ncurses (5.3.20030510-2) unstable; urgency=low

  * Bump shlibs version to 5.3.20030510-1 (Closes: #194633).
  * Move libncurses5-dbg and libncursesw5-dbg to libdevel also.
  * Install cons25 terminfo in ncurses-base for GNU/FreeBSD
    (Closes: #196232).

 -- Daniel Jacobowitz <dan@debian.org>  Sat, 14 Jun 2003 11:52:47 -0400

ncurses (5.3.20030510-1) unstable; urgency=low

  * New upstream snapshot.
    - Includes fix for a duplicate initialization bug (Closes: #192267).
  * Make the argument to define_key a "const char" (Closes: #192860).
  * Change the sections of libncurses5-dev and libncursesw5-dev.
  * Add a terminfo file for the Hurd terminal.
  * Provide a static libncurses_g.a.  I can't provide a shared one
    without introducing an rpath, since it has the same soname as a
    non-debugging version.

 -- Daniel Jacobowitz <dan@debian.org>  Wed, 14 May 2003 13:15:10 -0400

ncurses (5.3.20021109-2) unstable; urgency=low

  * Update screen terminfo entry (Closes: #165222).
  * Fix a typo in tset (Closes: #171583).

 -- Daniel Jacobowitz <dan@debian.org>  Wed,  4 Dec 2002 09:45:43 -0500

ncurses (5.3.20021109-1) unstable; urgency=low

  * New upstream version (Closes: #163512).
    - Thanks to Andreas for doing a lot of the grunt work.
    - Works around lameness in dpkg's build process (Closes: #165897).

 -- Daniel Jacobowitz <dan@debian.org>  Mon, 11 Nov 2002 14:58:33 -0500

ncurses (5.2.20020112a-8) unstable; urgency=low

  * Depend on libc-dev instead of libc6-dev (Closes: #145569).
  * Re-enable trace support in libncurses5-dbg (Closes: #146033).

 -- Daniel Jacobowitz <dan@debian.org>  Thu,  9 May 2002 17:46:11 -0400

ncurses (5.2.20020112a-7) unstable; urgency=low

  * Update screen terminfo from the screen package (Closes: #112826).

 -- Daniel Jacobowitz <dan@debian.org>  Fri, 29 Mar 2002 14:29:49 -0500

ncurses (5.2.20020112a-6) unstable; urgency=low

  * Add screen-bce terminfo (Closes: #138220).
  * Configure with --without-ada (Closes: #135024).

 -- Daniel Jacobowitz <dan@debian.org>  Mon, 18 Mar 2002 14:01:35 -0500

ncurses (5.2.20020112a-5) unstable; urgency=low

  * Fix documentation symlinks on upgrades (Closes: #134744).

 -- Daniel Jacobowitz <dan@debian.org>  Tue, 19 Feb 2002 17:26:49 -0500

ncurses (5.2.20020112a-4) unstable; urgency=low

  * Give all packages a common doc directory via symlinks.
  * Add a FAQ.
    - Document Print Screen on the console sending SIGQUIT
      (Closes: #53776).
    - Document ncurses applications resetting custom cursors
      (Closes: #55091).
    - Document the situation with Home and End
      (Closes: #131501, #89034, #98029, #107453, #107897, #116943,
       #119491, #130029, #99493).


=== debian/control ===
Source: ncurses
Section: libs
Priority: standard
Build-Depends: quilt, debhelper (>= 3.0.23), libc6-dev-sparc64 [sparc], libc6-dev-s390x [s390], lib64gcc1 [sparc s390]
Maintainer: Daniel Jacobowitz <ncurses-maint@debian.org>
Standards-Version: 3.6.1

Package: libncurses5
Architecture: any
Section: base
Priority: required
Depends: ${shlibs:Depends}
Description: Shared libraries for terminal handling
 This package contains the shared libraries necessary to run programs
 compiled with ncurses.

Package: libncurses5-dev
Architecture: any
Section: libdevel
Priority: optional
Depends: libncurses5 (= ${Source-Version}), libc-dev
Conflicts: ncurses-dev, ncurses-developer, libncurses-dev
Replaces: ncurses-dev, ncurses-developer, libncurses-dev
Provides: libncurses-dev, ncurses-dev
Description: Developer's libraries and docs for ncurses
 This package contains the header files, static libraries
 and symbolic links that developers using ncurses will need.
 It also includes the libraries' man pages and other documentation.

Package: libncurses5-dbg
Architecture: any
Section: libdevel
Priority: extra
Depends: libncurses5-dev (= ${Source-Version}), libncurses5 (= ${Source-Version})
Description: Debugging/profiling libraries for ncurses
 This package contains the debugging libraries for ncurses.

Package: libncursesw5
Architecture: any
Section: libs
Priority: standard
Depends: ${shlibs:Depends}
Description: Shared libraries for terminal handling (wide character support)
 This package contains the shared libraries necessary to run programs
 compiled with ncursesw, which includes support for wide characters.

Package: libncursesw5-dev
Architecture: any
Section: libdevel
Priority: optional
Depends: libncursesw5 (= ${Source-Version}), libc-dev
Suggests: libncurses5-dev
Description: Developer's libraries for ncursesw
 This package contains the header files, static libraries
 and symbolic links that developers using ncursesw will need.
 .
 This package includes support for wide characters.

Package: libncursesw5-dbg
Architecture: any
Section: libdevel
Priority: extra
Depends: libncursesw5-dev (= ${Source-Version}), libncursesw5 (= ${Source-Version})
Description: Debugging/profiling libraries for ncurses
 This package contains the debugging libraries for ncursesw.
 .
 This package includes support for wide characters.

Package: lib64ncurses5
Architecture: sparc s390
Section: libs
Priority: optional
Depends: ${shlibs:Depends}
Description: Shared libraries for terminal handling (64-bit)
 This package contains the shared libraries necessary to run programs
 compiled with ncurses.
 .
 This package supports the 64-bit ABI variant of your system's
 architecure.

Package: lib64ncurses5-dev
Architecture: sparc s390
Section: libdevel
Priority: optional
Depends: lib64ncurses5 (= ${Source-Version}), libncurses5-dev
Description: Developer's libraries for ncurses (64-bit)
 This package contains the header files, static libraries
 and symbolic links that developers using ncursesw will need.
 .
 This package supports the 64-bit ABI variant of your system's
 architecure.

Package: ncurses-bin
Architecture: any
Section: base
Priority: required
Essential: yes
Pre-Depends: ${shlibs:Depends}
Conflicts: ncurses, tput
Provides: tput
Description: Terminal-related programs and man pages
 This package contains the programs used for manipulating the terminfo
 database and individual terminfo entries, as well as some programs for
 resetting terminals and such.

Package: ncurses-base
Architecture: all
Section: base
Priority: required
Essential: yes
Conflicts: ncurses, ncurses-runtime
Provides: ncurses-runtime
Replaces: ncurses-term
Description: Descriptions of common terminal types
 This package contains what should be a reasonable subset of terminal
 definitions, including: ansi, dumb, linux, rxvt, screen, sun, vt100,
 vt102, vt220, vt52, and xterm.

Package: ncurses-term
Architecture: all
Section: admin
Priority: standard
Description: Additional terminal type definitions
 This package contains all of the terminal definitions not found in
 the ncurses-base package.  There are far too many to list here.

=== debian/rules ===
#!/usr/bin/make -f
# This file has gone through many maintainers.  Mostly rewritten
# by Daniel Jacobowitz.

# This is the debhelper compatability version to use.
export DH_COMPAT=3

# This has to be exported to make some magic below work.
export DH_OPTIONS

# These are important since this is a library package
soname=5
vername=5.7
sodepver = (>= 5.7-1)

# Name our packages
package-base=ncurses-base
package-bin=ncurses-bin
package-lib=libncurses$(soname)
package-lib-64=lib64ncurses$(soname)
package-libw=libncursesw$(soname)
package-dev=libncurses$(soname)-dev
package-dev-64=lib64ncurses$(soname)-dev
package-devw=libncursesw$(soname)-dev
package-dbg=libncurses$(soname)-dbg
package-dbgw=libncursesw$(soname)-dbg
package-term=ncurses-term

workdir=$(shell pwd)
tempdir=debian/tmp
fulltempdir=$(workdir)/$(tempdir)

srcdir=$(shell pwd)
objdir=$(srcdir)/obj
objdir-static=$(srcdir)/obj-static
objdir-64=$(srcdir)/obj-64
wobjdir=$(srcdir)/obj-wide
objdir-debug=$(srcdir)/obj-debug
wobjdir-debug=$(srcdir)/obj-wide-debug

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifeq ($(DEB_HOST_GNU_TYPE),s390-linux)
build_64_target = s390x-linux
build_64 = build-64
endif

ifeq ($(DEB_HOST_GNU_TYPE),sparc-linux)
build_64_target = sparc64-linux
build_64 = build-64
endif

CFLAGS = -O2 -g

ifneq (,$(findstring thumb,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -mthumb
endif

CONFARGS =	--prefix=/usr \
		--with-shared \
		--mandir='$${datadir}/man' \
		--without-profile --without-debug \
		--disable-rpath --enable-echo \
		--enable-const \
		--without-ada \
		--disable-termcap --with-terminfo-dirs="/etc/terminfo:/usr/share/terminfo"

# Directories and files for /etc/terminfo
etcterminfodirs=E a c d l m p r s v w x
etcterminfofiles=a/ansi c/cons25 c/cygwin d/dumb l/linux m/mach m/mach-bold \
	m/mach-color p/pcansi r/rxvt r/rxvt-m r/rxvt-basic s/screen \
	s/screen-bce s/screen-s s/screen-w s/sun v/vt100 v/vt102 \
	v/vt220 v/vt52 x/xterm x/xterm-debian x/xterm-xfree86 x/xterm-color \
	x/xterm-mono x/xterm-r5 x/xterm-r6 x/xterm-vt220 \
	w/wsvt25 w/wsvt25m E/Eterm E/Eterm-color

patch:
	env QUILT_PATCHES=$(CURDIR)/debian/patches quilt push -a
	touch $@

$(objdir)/config.status: patch
	test -d $(objdir) || mkdir $(objdir)
	cd $(objdir) && CFLAGS="$(CFLAGS)" $(srcdir)/configure \
		$(CONFARGS) \
		--with-install-prefix=$(fulltempdir) \
		--enable-overwrite

$(objdir-static)/config.status: patch
	test -d $(objdir-static) || mkdir $(objdir-static)
	cd $(objdir-static) && CFLAGS="$(CFLAGS)" $(srcdir)/configure \
		--without-shared --enable-static \
		--with-install-prefix=$(fulltempdir) \
		--enable-overwrite

$(objdir-64)/config.status: patch
	test -d $(objdir-64) || mkdir $(objdir-64)
	cd $(objdir-64) && CFLAGS="$(CFLAGS)" CC="gcc -m64" \
		BUILD_CC="gcc" CXX="g++ -m64" \
		$(srcdir)/configure \
		$(CONFARGS) \
		--build=$(DEB_BUILD_GNU_TYPE) \
		--host=$(build_64_target) \
		--with-install-prefix=$(fulltempdir) \
		--enable-overwrite --libdir=/usr/lib64

$(objdir-debug)/config.status: patch
	test -d $(objdir-debug) || mkdir $(objdir-debug)
	cd $(objdir-debug) && \
		CFLAGS="$(CFLAGS) -DTRACE" $(srcdir)/configure \
		$(CONFARGS) \
		--with-install-prefix=$(fulltempdir) \
		--enable-overwrite

$(wobjdir)/config.status: patch
	test -d $(wobjdir) || mkdir $(wobjdir)
	cd $(wobjdir) && CFLAGS="$(CFLAGS)" $(srcdir)/configure \
		$(CONFARGS) \
		--with-install-prefix=$(fulltempdir) \
		--disable-overwrite --enable-widec

$(wobjdir-debug)/config.status: patch
	test -d $(wobjdir-debug) || mkdir $(wobjdir-debug)
	cd $(wobjdir-debug) && \
		CFLAGS="$(CFLAGS) -DTRACE" $(srcdir)/configure \
		$(CONFARGS) \
		--with-install-prefix=$(fulltempdir) \
		--disable-overwrite --enable-widec

build: build-normal build-wide build-debug build-wide-debug build-static $(build_64)

build-normal: $(objdir)/config.status
	# For ia64...
	cd $(objdir)/c++ \
	  && cat Makefile | sed 's, -c ../c++/demo.cc, -O0 -c ../c++/demo.cc,' > Makefile.tem \
	  && mv -f Makefile.tem Makefile
	cd $(objdir) && $(MAKE)
	touch $@

build-static: $(objdir-static)/config.status
	cd $(objdir-static) && $(MAKE)
	touch $@

build-64: $(objdir-64)/config.status
	# For ia64...
	cd $(objdir-64)/c++ \
	  && cat Makefile | sed 's, -c ../c++/demo.cc, -O0 -c ../c++/demo.cc,' > Makefile.tem \
	  && mv -f Makefile.tem Makefile
	cd $(objdir-64) && $(MAKE)
	touch $@

build-debug: $(objdir-debug)/config.status
	# For ia64...
	cd $(objdir-debug)/c++ \
	  && cat Makefile | sed 's, -c ../c++/demo.cc, -O0 -c ../c++/demo.cc,' > Makefile.tem \
	  && mv -f Makefile.tem Makefile
	cd $(objdir-debug) && $(MAKE)
	touch $@

build-wide: $(wobjdir)/config.status
	# For ia64...
	cd $(wobjdir)/c++ \
	  && cat Makefile | sed 's, -c ../c++/demo.cc, -O0 -c ../c++/demo.cc,' > Makefile.tem \
	  && mv -f Makefile.tem Makefile
	cd $(wobjdir) && $(MAKE)
	touch $@

build-wide-debug: $(wobjdir-debug)/config.status
	# For ia64...
	cd $(wobjdir-debug)/c++ \
	  && cat Makefile | sed 's, -c ../c++/demo.cc, -O0 -c ../c++/demo.cc,' > Makefile.tem \
	  && mv -f Makefile.tem Makefile
	cd $(wobjdir-debug) && $(MAKE)
	touch $@

clean:
	dh_testdir
	dh_testroot
	-env QUILT_PATCHES=$(CURDIR)/debian/patches quilt pop -a
	rm -f build install
	rm -rf $(objdir)
	rm -rf $(objdir-64)
	rm -rf $(wobjdir)
	rm -rf $(objdir-debug)
	rm -rf $(wobjdir-debug)
	rm -f debian/shlibs.local
	dh_clean

install: DH_OPTIONS=
install: build
	# Generate proper debhelper files for so-named packages
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs -s
	dh_installdirs -i

ifneq ($(build_64),)
	$(MAKE) -C $(objdir-64) install.libs
	test -d $(tempdir)/lib64 || mkdir $(tempdir)/lib64
	mv $(tempdir)/usr/lib64/libncurses.so.$(vername) $(tempdir)/lib64/
	mv $(tempdir)/usr/lib64/libncurses.so.$(soname) $(tempdir)/lib64/
endif

	# Install into our base directory 
	GZIP='-9' $(MAKE) -C $(objdir-debug) install
	$(MAKE) -C $(wobjdir-debug) install.libs

	# Copy libraries to the debug directory
	test -d $(tempdir)/usr/lib/debug || mkdir $(tempdir)/usr/lib/debug
	cp -a $(tempdir)/usr/lib/*.so.* $(tempdir)/usr/lib/debug

	# Rename static debug libraries.
	for lib in $(tempdir)/usr/lib/*.a; do \
	  mv $$lib `echo $$lib | sed 's/\.a$$/_g.a/'`; \
	done

	# Install non -DTRACE versions.
	$(MAKE) -C $(objdir) install.libs
	$(MAKE) -C $(wobjdir) install.libs

	# Compile this before moving files into their packages.
	for ti in xterm hurd rxvt screen; do \
		TERMINFO=$(fulltempdir)/usr/share/terminfo \
		$(objdir-static)/progs/tic debian/$$ti.ti; \
	done

	# We keep the libncurses shared library in /lib.
	test -d $(tempdir)/lib || mkdir $(tempdir)/lib
	mv $(tempdir)/usr/lib/libncurses.so.$(vername) $(tempdir)/lib/
	mv $(tempdir)/usr/lib/libncurses.so.$(soname) $(tempdir)/lib/

	dh_movefiles -s
	dh_movefiles -i

	# We keep the libncurses shared library in /lib.
	ln -sf /lib/libncurses.so.$(soname) debian/$(package-dev)/usr/lib/libncurses.so
ifneq ($(build_64),)
	ln -sf /lib64/libncurses.so.$(soname) debian/$(package-dev-64)/usr/lib64/libncurses.so
endif

	# By tradition, we provide -lcurses and -ltermcap.
	ln -sf libncurses.so debian/$(package-dev)/usr/lib/libcurses.so
	ln -sf libncurses.so debian/$(package-dev)/usr/lib/libtermcap.so
	ln -sf libncurses.a debian/$(package-dev)/usr/lib/libtermcap.a
	ln -sf libncurses.a debian/$(package-dev)/usr/lib/libcurses.a

	# Move terminfo entries for ncurses-base to /etc
	mv debian/$(package-base)/usr/share/terminfo debian/$(package-base)/etc

	# Break hard links.
	cp $(workdir)/debian/$(package-base)/etc/terminfo/r/rxvt-m \
	   $(workdir)/debian/$(package-base)/etc/terminfo/r/rxvt-foo
	rm -f $(workdir)/debian/$(package-base)/etc/terminfo/r/rxvt-m
	mv $(workdir)/debian/$(package-base)/etc/terminfo/r/rxvt-foo \
	   $(workdir)/debian/$(package-base)/etc/terminfo/r/rxvt-m

	cp $(workdir)/debian/$(package-base)/etc/terminfo/E/Eterm-color \
	   $(workdir)/debian/$(package-base)/etc/terminfo/E/Eterm-color-foo

## ncurses 5.7+20101128

=== debian/changelog ===
ncurses (5.7+20101128-1) experimental; urgency=low

  [ Sven Joachim ]
  * New upstream patchlevel.
    - Clarify that infotocap, captoinfo and tic read text files and do
      not work with compiled terminfo files (Closes: #593920).
  * Remove dangling /usr/share/terminfo/k/kon2 symlink (Closes: #522435).
  * Add an ncurses-examples package containing the compiled test programs
    (Closes: #34182).  Stop shipping the sources in libncurses5-dev.
  * Move documentation and section 3 manpages to a new ncurses-doc package
    (Closes: #233400).  Suggest ncurses-doc in all -dev packages.
  * Register the documentation in doc-base (Closes: #451667).
  * Remove the rather useless README.Debian (Closes: #606034).
  * Move libtic libraries to /usr.
  * Tighten the dependencies of the lib{32,64}ncurses*-dev packages to their
    regular counterparts.
  * Provide symbols files in all library packages.
    - Use them to compute the dependencies of the other packages instead of
      messing around with local shlibs files.
  * Ship mlterm terminfo in ncurses-term (see #485448).
  * Ship curses and termcap symlinks in lib{32,64}ncurses5-dev (LP: #485118).
  * Add lintian override for the empty /usr/share/terminfo directory that
    was introduced in 5.7+20100313-2.
  * Stop building the test programs in every library build.
  * Fix non-idempotency of the install (and thus the binary) target in
    debian/rules introduced in 5.7+20100313-1.
  * Do not unnecessarily add /lib32 and /usr/lib32 to dh_shlibdeps' search
    path when calculating the dependencies of the 32-bit libraries.
  * Do not allow dh_shlibdeps to fail for the 64-bit libraries.
  * Drop most patches as obsolete or unused:
    - 09-fix-delscreen-segfault.diff, applied upstream.
    - 06-kfreebsd.diff, apparently no longer needed.
    - 03-linux-use-fsuid.diff, patched code that is not compiled if ncurses
      is configured with "--disable-termcap", as we do.
    - 01-use-d-reentrant.diff, no longer needed since all architectures moved
      away from LinuxThreads and Policy 3.9.1 has explicitly removed the need
      to #define _REENTRANT.
  * Refresh all remaining Debian patches and add DEP-3 headers to them.
  * Remove the fix for bug #127622 from 02-debian-backspace.diff,
    no longer needed.
  * Update patch 02-debian-backspace.diff to get kbs=\177 in all screen-*
    terminfo entries (Closes: #602300).
  * Drop the rather outdated screen terminfo from the debian directory and use
    the one provided by upstream's terminfo.src instead.
  * Get CFLAGS, CXXFLAGS and LDFLAGS from dpkg-buildflags, adding a build
    dependency on dpkg-dev (>= 1.15.7).
  * Switch to format 3.0 (quilt).
    - Remove quilt build dependency and patch/unpatch logic from debian/rules.
    - Drop debian/README.source.
  * Add a debian/watch file.
  * Extend the package descriptions.
  * Remove duplicate "Priority:" fields from debian/control.
  * Update debian/copyright:
    - Update FSF Copyright years.
    - Mention other copyright holders and licenses.
    - Give a pointer to the current location of the ncurses sources.
    - Stop mentioning Debian changes.
  * Upgrade Standards-Version to 3.9.1, no changes needed.

  [ Loïc Minier ]
  * Update patch 05-emdebian-wchar to apply cleanly.
  * Drop 08-pkg-config-libdir patch as dpkg >= 1.15.6 don't set
    PKG_CONFIG_LIBDIR anymore.

  [ Steve Langasek ]
  * Export LDFLAGS in debian/rules (Closes: #586144).

 -- Sven Joachim <svenjoac@gmx.de>  Mon, 29 Nov 2010 16:41:55 +0100

ncurses (5.7+20100313-4) unstable; urgency=low

  * New patch 09-fix-delscreen-segfault.diff taken from upstream
    patchlevel 20100501, fixes a segfault or infinite loop in applications
    using multiple screens (Closes: #597175).

 -- Sven Joachim <svenjoac@gmx.de>  Tue, 28 Sep 2010 07:08:17 +0200

ncurses (5.7+20100313-3) unstable; urgency=low

  * Fix dangling symlinks in ncurses-term that were introduced by the
    removal of the ncurses-base compatibility symlinks in version
    5.7+20100313-1 (Closes: #576127).  Add versioned Breaks against older
    ncurses-term versions in ncurses-base.
  * Correct rxvt-unicode sgr0 terminfo entry (Closes: #595484).

 -- Sven Joachim <svenjoac@gmx.de>  Sat, 11 Sep 2010 21:13:00 +0200

ncurses (5.7+20100313-2) unstable; urgency=medium

  [ Sven Joachim ]
  * Disable rmm and smm features in xterm terminfo entry (see #574396).
  * Include an empty /usr/share/terminfo directory in ncurses-bin to
    ensure that configure scripts detect terminfo support (Closes: #575284).
  * Let libncurses5-dev and libncursesw5-dev depend on the same version of
    ncurses-bin to mitigate the impact of #480437.
  * Explicitly specify source format 1.0 (lintian warning).

 -- Sven Joachim <svenjoac@gmx.de>  Thu, 25 Mar 2010 14:13:38 +0100

ncurses (5.7+20100313-1) unstable; urgency=low

  [ Sven Joachim ]
  * New upstream patchlevel.
    - Workaround for bug in g++ 4.1-4.4 warnings for wattrset() macro
      on amd64 (Closes: #542031).
    - Fix typo in curs_mouse.3x (Closes: #429198).
    - Modify CF_MAN_PAGES configure macro to replace all occurrences of
      TPUT in tput.1's manpage (Closes: #573597).
    - Bump shlibs version, as there are several new symbols.
  * Remove patch introduced in 5.5-2, applied upstream. Remove patch
    introduced in version 5.7+20090627-1, no longer necessary.
  * Switch patch system to quilt.
    - Add a short debian/README.source as recommended by policy.
  * Configure with /usr/share/terminfo as default terminfo dir, so that
    we get the correct tabset directory (Closes: #509919, LP: #200773).
  * Update xterm terminfo entry from xterm 246 (Closes: #444250).
  * Derive xterm{16,256,88}-color from xterm-debian rather than
    xterm-new for correct backspace key behavior.
  * Move the debugging libraries back to /usr/lib/debug (Closes: #553239),
    ship detached debugging symbols (Closes: #532022).
  * Fix typo in debian/rules that lead to a dangling symlink in


=== debian/control ===
Source: ncurses
Section: libs
Priority: required
Maintainer: Craig Small <csmall@debian.org>
Uploaders: Sven Joachim <svenjoac@gmx.de>
Build-Depends: debhelper (>= 7),
               dpkg-dev (>= 1.15.7),
               g++-multilib [amd64 i386 kfreebsd-amd64 powerpc ppc64 s390 sparc],
               libgpm-dev [!hurd-i386 !kfreebsd-amd64 !kfreebsd-i386],
Standards-Version: 3.9.1
Vcs-Browser: http://git.debian.org/?p=collab-maint/ncurses.git
Vcs-Git: git://git.debian.org/collab-maint/ncurses.git
Homepage: http://invisible-island.net/ncurses/

Package: libncurses5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libgpm2 [!hurd-i386 !kfreebsd-amd64 !kfreebsd-i386]
Description: shared libraries for terminal handling
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the shared libraries necessary to run programs
 compiled with ncurses.

Package: libncurses5-dev
Architecture: any
Section: libdevel
Priority: optional
Depends: libncurses5 (= ${binary:Version}), ncurses-bin (= ${binary:Version}),
	 libc-dev, ${misc:Depends}
Conflicts: ncurses-dev, libncurses-dev
Replaces: ncurses-dev, libncurses-dev
Provides: libncurses-dev, ncurses-dev
Suggests: ncurses-doc
Description: developer's libraries for ncurses
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the header files, static libraries
 and symbolic links that developers using ncurses will need.

Package: libncurses5-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${shlibs:Depends}, libncurses5-dev (= ${binary:Version}), ${misc:Depends}
Description: debugging/profiling libraries for ncurses
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains special library versions of ncurses suitable
 for debugging and profiling. Also included are detached debugging
 symbols for libncurses5.

Package: libncursesw5
Architecture: any
Priority: important
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libgpm2 [!hurd-i386 !kfreebsd-amd64 !kfreebsd-i386]
Description: shared libraries for terminal handling (wide character support)
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the shared libraries necessary to run programs
 compiled with ncursesw, which includes support for wide characters.

Package: libncursesw5-dev
Architecture: any
Section: libdevel
Priority: optional
Depends: libncursesw5 (= ${binary:Version}), ncurses-bin (= ${binary:Version}),
	 libc-dev, ${misc:Depends}
Suggests: ncurses-doc
Description: developer's libraries for ncursesw
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the header files, static libraries
 and symbolic links that developers using ncursesw will need.
 .
 This package includes support for wide characters.

Package: libncursesw5-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${shlibs:Depends}, libncursesw5-dev (= ${binary:Version}), ${misc:Depends}
Description: debugging/profiling libraries for ncursesw
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains special library versions of ncursesw suitable
 for debugging and profiling. Also included are detached debugging
 symbols for libncursesw5.
 .
 This package includes support for wide characters.

Package: lib64ncurses5
Architecture: i386 powerpc sparc s390
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: amd64-libs (<= 1.2)
Description: shared libraries for terminal handling (64-bit)
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the shared libraries necessary to run programs
 compiled with ncurses.
 .
 This package supports the 64-bit ABI variant of your system's
 architecure.

Package: lib64ncurses5-dev
Architecture: i386 powerpc sparc s390
Section: libdevel
Priority: optional
Depends: lib64ncurses5 (= ${binary:Version}),
	 libncurses5-dev (= ${binary:Version}), lib64c-dev, ${misc:Depends}
Suggests: ncurses-doc
Replaces: amd64-libs-dev (<= 1.2)
Description: developer's libraries for ncurses (64-bit)
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the header files, static libraries
 and symbolic links that developers using ncurses will need.
 .
 This package supports the 64-bit ABI variant of your system's
 architecure.

Package: lib32ncurses5
Architecture: amd64 ppc64
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libc6-i386 (<= 2.9-18)
Replaces: ia32-libs (<< 1.10)
Description: shared libraries for terminal handling (32-bit)
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the shared libraries necessary to run programs
 compiled with ncurses.
 .
 This package supports the 32-bit ABI variant of your system's
 architecure.

Package: lib32ncurses5-dev
Architecture: amd64 ppc64
Section: libdevel
Priority: optional
Depends: lib32ncurses5 (= ${binary:Version}),
	 libncurses5-dev (= ${binary:Version}), lib32c-dev, ${misc:Depends}
Suggests: ncurses-doc
Conflicts: libc6-i386 (<= 2.9-18)
Description: developer's libraries for ncurses (32-bit)
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the header files, static libraries
 and symbolic links that developers using ncurses will need.
 .
 This package supports the 32-bit ABI variant of your system's
 architecure.

Package: lib32ncursesw5
Architecture: amd64 ppc64
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libc6-i386 (<= 2.9-18)
Description: shared libraries for terminal handling (wide character support) (32-bit)
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the shared libraries necessary to run programs
 compiled with ncursesw, which includes support for wide characters.
 .
 This package supports the 32-bit ABI variant of your system's
 architecure.

Package: lib32ncursesw5-dev
Architecture: amd64 ppc64
Section: libdevel
Priority: optional
Depends: lib32ncursesw5 (= ${binary:Version}),
	 libncursesw5-dev (= ${binary:Version}), lib32c-dev, ${misc:Depends}
Conflicts: libc6-i386 (<= 2.9-18)
Suggests: ncurses-doc
Description: developer's libraries for ncursesw (32-bit)
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the header files, static libraries
 and symbolic links that developers using ncursesw will need.
 .
 This package includes support for wide characters.
 This package supports the 32-bit ABI variant of your system's
 architecure.

Package: ncurses-bin
Architecture: any
Section: utils
Essential: yes
Pre-Depends: ${shlibs:Depends}, ${misc:Depends}
Description: terminal-related programs and man pages
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the programs used for manipulating the terminfo
 database and individual terminfo entries, as well as some programs for
 resetting terminals and such.

Package: ncurses-base
Architecture: all
Section: utils
Essential: yes
Depends: ${misc:Depends}
Conflicts: ncurses, ncurses-runtime
Provides: ncurses-runtime
Breaks: ncurses-term (<< 5.7+20100313-3)
Description: basic terminal type definitions
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains terminfo data files to support the most common types of
 terminal, including ansi, dumb, linux, rxvt, screen, sun, vt100, vt102, vt220,
 vt52, and xterm.

Package: ncurses-term
Architecture: all
Section: admin
Priority: standard
Depends: ${misc:Depends}
Replaces: ncurses-base (<< 5.7+20100313-1), mlterm-common (<< 3.0.1-4)
Breaks: mlterm-common (<< 3.0.1-4)
Description: additional terminal type definitions
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains all of the numerous terminal definitions not found in
 the ncurses-base package.

Package: ncurses-examples
Architecture: any
Section: misc
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: test programs and examples for ncurses
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains programs demonstrating the possibilities of
 ncurses and testing the library. The examples include an
 analog/digital clock and several classic programs such as solitaire,
 battleships, a knight's tour on a chess board, the towers of Hanoi
 and several others.

Package: ncurses-doc
Architecture: all
Section: doc
Priority: optional
Depends: ${misc:Depends}
Replaces: libncurses5-dev (<< 5.7+20101128)
Description: developer's guide and documentation for ncurses
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains an introduction to writing programs with
 ncurses a guide to the internals of the ncurses library.  It also
 includes the libraries' man pages.
 .
 Non-developers likely have little use for this package.

=== debian/rules ===
#!/usr/bin/make -f
# This file has gone through many maintainers.  Mostly rewritten
# by Daniel Jacobowitz.

CFLAGS := $(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)

# These are important since this is a library package
soname=5
vername=5.7
sodepver = (>= 5.7+20100313)

# Name our packages
package-base=ncurses-base
package-bin=ncurses-bin
package-lib=libncurses$(soname)
package-lib-32=lib32ncurses$(soname)
package-lib-64=lib64ncurses$(soname)
package-libw=libncursesw$(soname)
package-libw-32=lib32ncursesw$(soname)
package-dev=libncurses$(soname)-dev
package-dev-32=lib32ncurses$(soname)-dev
package-dev-64=lib64ncurses$(soname)-dev
package-devw=libncursesw$(soname)-dev
package-devw-32=lib32ncursesw$(soname)-dev
package-dbg=libncurses$(soname)-dbg
package-dbgw=libncursesw$(soname)-dbg
package-term=ncurses-term
package-examples=ncurses-examples

workdir=$(shell pwd)
tempdir=debian/tmp
fulltempdir=$(workdir)/$(tempdir)

srcdir=$(shell pwd)
objdir=$(srcdir)/obj
objdir-static=$(srcdir)/obj-static
objdir-32=$(srcdir)/obj-32
objdir-64=$(srcdir)/obj-64
wobjdir=$(srcdir)/obj-wide
wobjdir-static=$(srcdir)/obj-wide-static
wobjdir-32=$(srcdir)/obj-wide-32
objdir-debug=$(srcdir)/obj-debug
wobjdir-debug=$(srcdir)/obj-wide-debug
objdir-test=$(srcdir)/obj-test

DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_GNU_SYSTEM ?= $(shell dpkg-architecture -qDEB_HOST_GNU_SYSTEM)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

ifeq ($(DEB_HOST_ARCH),i386)
build_64_target = x86_64-$(DEB_HOST_GNU_SYSTEM)
build_64 = build-64
endif

ifeq ($(DEB_HOST_ARCH),powerpc)
build_64_target = powerpc64-$(DEB_HOST_GNU_SYSTEM)
build_64 = build-64
endif

ifeq ($(DEB_HOST_ARCH),s390)
build_64_target = s390x-$(DEB_HOST_GNU_SYSTEM)
build_64 = build-64
endif

ifeq ($(DEB_HOST_ARCH),sparc)
build_64_target = sparc64-$(DEB_HOST_GNU_SYSTEM)
build_64 = build-64
endif

ifeq ($(DEB_HOST_ARCH),amd64)
build_32_target = i486-$(DEB_HOST_GNU_SYSTEM)
build_32 = build-32 build-wide-32
lib32 = /lib32
usr_lib32 = /usr/lib32
endif

ifeq ($(DEB_HOST_ARCH),ppc64)
build_32_target = powerpc-$(DEB_HOST_GNU_SYSTEM)
build_32 = build-32 build-wide-32
lib32 = /lib32
usr_lib32 = /usr/lib32
endif

ifneq ($(findstring linux,$(DEB_HOST_GNU_SYSTEM)),)
with_gpm = --with-gpm
endif

CONFARGS =	--prefix=/usr \
		--with-shared \
		--mandir=/usr/share/man \
		--without-profile --without-debug \
		--disable-rpath --enable-echo \
		--enable-const \
		--without-ada \
		--without-tests \
		$(with_gpm) \
		--enable-symlinks \
		--disable-lp64 \
		--with-chtype='long' \
		--with-mmask-t='long' \
		--disable-termcap \
		--with-default-terminfo-dir=/usr/share/terminfo \
		--with-terminfo-dirs="/etc/terminfo:/lib/terminfo:/usr/share/terminfo" \
		--with-ticlib

CONFARGS-TEST =	--prefix=/usr \
		--bindir=/usr/lib/ncurses/examples \
		--with-curses-dir=$(objdir)

ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
CONFARGS += --with-build-cc=gcc --host=$(DEB_HOST_GNU_TYPE)
CONFARGS-TEST += --with-build-cc=gcc --host=$(DEB_HOST_GNU_TYPE)
endif

# Files for /lib/terminfo.
libterminfofiles=a/ansi c/cons25 c/cygwin d/dumb h/hurd l/linux m/mach \
	m/mach-bold m/mach-color p/pcansi r/rxvt r/rxvt-m r/rxvt-basic \
	r/rxvt-unicode \
	s/screen s/screen-bce s/screen-s s/screen-w s/sun v/vt100 v/vt102 \
	v/vt220 v/vt52 x/xterm x/xterm-debian x/xterm-xfree86 x/xterm-color \
	x/xterm-mono x/xterm-r5 x/xterm-r6 x/xterm-vt220 \
	x/xterm-256color s/screen-256color s/screen-256color-bce \
	w/wsvt25 w/wsvt25m E/Eterm E/Eterm-color

# Blacklist terminfo entries shipped by other Debian packages so that we do
# not begin shipping them by accident.
badterminfo = 5/5250 b/bterm i/iterm i/iterm-am i/iterm-color \
	j/jfbterm k/kon k/kon2 l/linux-5250

# The ncurses configure test won't work when cross compiling (e.g. for
# 64 bit libraries), so force the libgpm soname to the correct value.
export cf_cv_gpm_soname=libgpm.so.2

$(objdir)/config.status:
	test -d $(objdir) || mkdir $(objdir)
	cd $(objdir) && CFLAGS="$(CFLAGS)" $(srcdir)/configure \
		$(CONFARGS) \
		--with-install-prefix=$(fulltempdir) \
		--enable-overwrite

$(objdir-static)/config.status:
	test -d $(objdir-static) || mkdir $(objdir-static)
	cd $(objdir-static) && CFLAGS="$(CFLAGS)" $(srcdir)/configure \
		$(CONFARGS) \
		--without-shared \
		--without-dlsym \
		--with-install-prefix=$(fulltempdir) \
		--enable-overwrite

$(objdir-32)/config.status:
	test -d $(objdir-32) || mkdir $(objdir-32)

	cd $(objdir-32) && CFLAGS="$(CFLAGS)" CC="gcc -m32" \
		BUILD_CC="gcc" CXX="g++ -m32" \
		$(srcdir)/configure \
		$(CONFARGS) \
		--build=$(DEB_BUILD_GNU_TYPE) \
		--host=$(build_32_target) \
		--without-gpm \
		--with-install-prefix=$(fulltempdir) \
		--enable-overwrite --libdir=$(usr_lib32)

$(objdir-64)/config.status:
	test -d $(objdir-64) || mkdir $(objdir-64)

	# Force necessary configure checks which do not work when
	# cross compiling; all Debian platforms return unsigned char
	# for this configure check.
	cf_cv_type_of_bool='unsigned char'; export cf_cv_type_of_bool; \
	cd $(objdir-64) && CFLAGS="$(CFLAGS)" CC="gcc -m64" \
		BUILD_CC="gcc" CXX="g++ -m64" \
		$(srcdir)/configure \
		$(CONFARGS) \
		--build=$(DEB_BUILD_GNU_TYPE) \
		--host=$(build_64_target) \
		--without-gpm \
		--with-install-prefix=$(fulltempdir) \
		--enable-overwrite --libdir=/usr/lib64

$(objdir-debug)/config.status:
	test -d $(objdir-debug) || mkdir $(objdir-debug)
	cd $(objdir-debug) && \
		CFLAGS="$(CFLAGS) -DTRACE" $(srcdir)/configure \
		$(CONFARGS) \
		--with-install-prefix=$(fulltempdir) \
		--enable-overwrite

$(wobjdir)/config.status:
	test -d $(wobjdir) || mkdir $(wobjdir)
	cd $(wobjdir) && CFLAGS="$(CFLAGS)" $(srcdir)/configure \
		$(CONFARGS) \
		--with-install-prefix=$(fulltempdir) \
		--disable-overwrite --enable-widec

$(wobjdir-static)/config.status:
	test -d $(wobjdir-static) || mkdir $(wobjdir-static)
	cd $(wobjdir-static) && CFLAGS="$(CFLAGS)" $(srcdir)/configure \
		$(CONFARGS) \
		--without-shared \
		--without-dlsym \
		--with-install-prefix=$(fulltempdir) \
		--disable-overwrite --enable-widec

$(wobjdir-debug)/config.status:
	test -d $(wobjdir-debug) || mkdir $(wobjdir-debug)
	cd $(wobjdir-debug) && \
		CFLAGS="$(CFLAGS) -DTRACE" $(srcdir)/configure \
		$(CONFARGS) \
		--with-install-prefix=$(fulltempdir) \
		--disable-overwrite --enable-widec

$(wobjdir-32)/config.status:
	test -d $(wobjdir-32) || mkdir $(wobjdir-32)

	cd $(wobjdir-32) && CFLAGS="$(CFLAGS)" CC="gcc -m32" \
		BUILD_CC="gcc" BUILD_CPPFLAGS="-D_GNU_SOURCE" CXX="g++ -m32" \
		$(srcdir)/configure \
		$(CONFARGS) \
		--build=$(DEB_BUILD_GNU_TYPE) \
		--host=$(build_32_target) \
		--without-gpm \
		--with-install-prefix=$(fulltempdir) \
		--disable-overwrite --enable-widec \
		--libdir=$(usr_lib32)

$(objdir-test)/config.status: build-normal
	test -d $(objdir-test) || mkdir $(objdir-test)
	cd $(objdir-test) && CFLAGS="$(CFLAGS)" $(srcdir)/test/configure \
		$(CONFARGS-TEST)

build: build-normal build-static build-wide build-debug build-wide-debug \
	build-wide-static build-test $(build_64) $(build_32)

	touch $@

build-normal: $(objdir)/config.status
	cd $(objdir) && $(MAKE)
	touch $@

build-static: $(objdir-static)/config.status
	cd $(objdir-static) && $(MAKE)
	touch $@

build-32: $(objdir-32)/config.status
	cd $(objdir-32) && $(MAKE)
	touch $@

build-64: $(objdir-64)/config.status
	cd $(objdir-64) && $(MAKE)
	touch $@

build-debug: $(objdir-debug)/config.status
	cd $(objdir-debug) && $(MAKE)
	touch $@

build-wide: $(wobjdir)/config.status
	cd $(wobjdir) && $(MAKE)
	touch $@

build-wide-static: $(wobjdir-static)/config.status
	cd $(wobjdir-static) && $(MAKE)
	touch $@

build-wide-32: $(wobjdir-32)/config.status
	cd $(wobjdir-32) && $(MAKE)
	touch $@

build-wide-debug: $(wobjdir-debug)/config.status
	cd $(wobjdir-debug) && $(MAKE)

=== debian/watch ===
version=3

opts=passive ftp://invisible-island.net/ncurses/ncurses-(.*)\.tar\.gz \
 debian uupdate

# Above entry is for releases, if you want to check for the weekly snapshots,
# uncomment the following entry.

# opts=passive,uversionmangle=s/-/+/ \
#  ftp://invisible-island.net/ncurses/current/ncurses-(.*)\.tgz debian uupdate
